var objDogEarOptions = {

	objPrefs : Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefService).getBranch('extensions.dogears.'),
	objMediator: Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator),

	Init: function()
	{
		this.ndLastViewed = document.getElementById('dogears-general-lastviewed');
		this.ndConfirmRemovePage = document.getElementById('dogears-general-confirmremovepage');
		this.ndConfirmRemoveAll = document.getElementById('dogears-general-confirmremoveall');
		this.ndShortcutMark = document.getElementById('dogears-shortcut-mark');
		this.ndShortcutKeyboardMark = document.getElementById('dogears-shortcut-keyboard-mark');
		this.ndShortcutMove = document.getElementById('dogears-shortcut-move');
		this.ndShortcutClear = document.getElementById('dogears-shortcut-clear');
		this.ndShortcutSidebar = document.getElementById('dogears-shortcut-sidebar');
		this.ndContextMenu = document.getElementById('dogears-contextmenu');
		this.ndStatusBar = document.getElementById('dogears-statusbar');

		this.ndLastViewed.checked = this.objPrefs.prefHasUserValue('lastviewed') ? this.objPrefs.getBoolPref('lastviewed') : false;
		this.ndConfirmRemovePage.checked = this.objPrefs.prefHasUserValue('confirmremovepage') ? this.objPrefs.getBoolPref('confirmremovepage') : true;
		this.ndConfirmRemoveAll.checked = this.objPrefs.prefHasUserValue('confirmremoveall') ? this.objPrefs.getBoolPref('confirmremoveall') : true;
		this.ndShortcutMark.checked = this.objPrefs.prefHasUserValue('shortcutmark') ? this.objPrefs.getBoolPref('shortcutmark') : true;
		this.ndShortcutKeyboardMark.checked = this.objPrefs.prefHasUserValue('shortcutkeyboardmark') ? this.objPrefs.getBoolPref('shortcutkeyboardmark') : true;
		this.ndShortcutMove.checked = this.objPrefs.prefHasUserValue('shortcutmove') ? this.objPrefs.getBoolPref('shortcutmove') : true;
		this.ndShortcutClear.checked = this.objPrefs.prefHasUserValue('shortcutclear') ? this.objPrefs.getBoolPref('shortcutclear') : true;
		this.ndShortcutSidebar.checked = this.objPrefs.prefHasUserValue('shortcutsidebar') ? this.objPrefs.getBoolPref('shortcutsidebar') : true;
		this.ndContextMenu.checked = this.objPrefs.prefHasUserValue('contextmenu') ? this.objPrefs.getBoolPref('contextmenu') : true;
		this.ndStatusBar.checked = this.objPrefs.prefHasUserValue('statusbar') ? this.objPrefs.getBoolPref('statusbar') : true;

		var bDisplaySidebar = false;
		var objWindows = objDogEarOptions.objMediator.getEnumerator('navigator:browser');
		while (objWindows.hasMoreElements())
		{
			var objWindow = objWindows.getNext();
			if (objWindow.objDogEar && objWindow.objDogEar.objDBService) bDisplaySidebar = true;
		}

		if (!bDisplaySidebar)
		{
			this.ndShortcutSidebar.parentNode.removeChild(this.ndShortcutSidebar);
			this.ndShortcutSidebar = null;
		}

		return true;
	},

	Update: function()
	{
		if (this.ndShortcutSidebar)
		{
			this.objPrefs.setBoolPref('shortcutsidebar', this.ndShortcutSidebar.checked);
		}
		else
		{
			this.objPrefs.setBoolPref('shortcutsidebar', false);
		}

		this.objPrefs.setBoolPref('lastviewed', this.ndLastViewed.checked);
		this.objPrefs.setBoolPref('confirmremovepage', this.ndConfirmRemovePage.checked);
		this.objPrefs.setBoolPref('confirmremoveall', this.ndConfirmRemoveAll.checked);
		this.objPrefs.setBoolPref('shortcutmark', this.ndShortcutMark.checked);
		this.objPrefs.setBoolPref('shortcutkeyboardmark', this.ndShortcutKeyboardMark.checked);
		this.objPrefs.setBoolPref('shortcutmove', this.ndShortcutMove.checked);
		this.objPrefs.setBoolPref('shortcutclear', this.ndShortcutClear.checked);
		this.objPrefs.setBoolPref('contextmenu', this.ndContextMenu.checked);
		this.objPrefs.setBoolPref('statusbar', this.ndStatusBar.checked);

		var objWindows = objDogEarOptions.objMediator.getEnumerator('navigator:browser');
		while (objWindows.hasMoreElements())
		{
			var objWindow = objWindows.getNext();
			if (objWindow.objDogEar) objWindow.document.getElementById('dogears-statusbar').collapsed = !this.ndStatusBar.checked;
		}

		return true;
	}
};