var objDogEarSidebar =
{
	objMediator: Components.classes['@mozilla.org/appshell/window-mediator;1'].getService(Components.interfaces.nsIWindowMediator),
	objMozillaPrefs: Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefBranch),
	objPrefs: Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefService).getBranch('extensions.dogears.'),
	objStringBundle: null,

	Init: function()
	{
		objDogEarSidebar.objStringBundle = document.getElementById('dogears-string-bundle');
		document.getElementById('dogears-sidebar-tree').view = objDogEarTreeView;

		var sSort = objDogEarSidebar.objPrefs.getCharPref('sidebarsort');
		var aColumns = document.getElementById('dogears-sidebar-tree').getElementsByTagName('treecol');
		for (var nColumn = 0; aColumns[nColumn]; ++nColumn)
		{
			aColumns[nColumn].removeAttribute('class');
			aColumns[nColumn].removeAttribute('sortDirection');

			if (aColumns[nColumn].id == 'sidebar-' + sSort)
			{
				aColumns[nColumn].className = 'sortDirectionIndicator';
				aColumns[nColumn].setAttribute('sortDirection', 'ascending');
			}
			else if (aColumns[nColumn].id == 'sidebar-' + sSort.substring(0, sSort.indexOf('_desc')))
			{
				aColumns[nColumn].className = 'sortDirectionIndicator';
				aColumns[nColumn].setAttribute('sortDirection', 'descending');
			}
		}

		return true;
	},

	Sort: function(ndColumn)
	{
		var sCurrentSort = this.objPrefs.getCharPref('sidebarsort');
		var sClickedSort = ndColumn.id.substring(ndColumn.id.indexOf('-') + 1);

		if (sCurrentSort == sClickedSort)
		{
			sClickedSort = (sCurrentSort.indexOf('_desc') == -1) ? sCurrentSort + '_desc' : sCurrentSort.substring(0, sCurrentSort.indexOf('_desc'));
		}

		var aColumns = document.getElementById('dogears-sidebar-tree').getElementsByTagName('treecol');
		for (var nColumn = 0; aColumns[nColumn]; ++nColumn)
		{
			aColumns[nColumn].removeAttribute('class');
			aColumns[nColumn].removeAttribute('sortDirection');

			if (aColumns[nColumn].id == ndColumn.id)
			{
				aColumns[nColumn].className = 'sortDirectionIndicator';
				aColumns[nColumn].setAttribute('sortDirection', ((sClickedSort.indexOf('_desc') == -1) ? 'ascending' : 'descending'));
			}
		}

		this.objPrefs.setCharPref('sidebarsort', sClickedSort);
		objDogEarTreeView.treeBox.invalidate();

		return true;
	},

	Open: function(nIndex)
	{
		var sURL = this.GetRowCell(nIndex, 'sidebar-url');
		var objBrowser = this.objMediator.getMostRecentWindow('navigator:browser').getBrowser();

		objBrowser.loadURI(sURL, null, null);

		return true;
	},

	OpenWindow: function(nIndex)
	{
		var sURL = this.GetRowCell(nIndex, 'sidebar-url');

		window.open(sURL);

		return true;
	},

	OpenTab: function(nIndex)
	{
		var bTabDefault = (this.objMozillaPrefs.getPrefType('browser.tabs.loadInBackground') == this.objMozillaPrefs.PREF_BOOL) ? this.objMozillaPrefs.getBoolPref('browser.tabs.loadInBackground') : true;
		var sURL = this.GetRowCell(nIndex, 'sidebar-url');
		var objBrowser = this.objMediator.getMostRecentWindow('navigator:browser').getBrowser();

		var objTab = objBrowser.addTab(sURL, null, null);
		if (!bTabDefault) objBrowser.selectedTab = objTab;

		return true;
	},

	Delete: function(nIndex)
	{
		if ((!this.objPrefs.prefHasUserValue('confirmremovepage') || this.objPrefs.getBoolPref('confirmremovepage')) && !confirm(this.objStringBundle.getString('dogears.removepage'))) return true;

		var sURL = this.GetRowCell(objDogEarTreeView.selection.currentIndex, 'sidebar-url');
		var objDogEar = this.GetDogEar();

		objDogEar.UpdateSidebarRowCount(nIndex, -1);

		objDogEar.BeginTransaction();
		objDogEar.objDeleteAllMarks.bindUTF8StringParameter(0, sURL);
		objDogEar.objDeleteAllMarks.execute();

		objDogEar.BeginTransaction();
		objDogEar.objDeletePage.bindUTF8StringParameter(0, sURL);
		objDogEar.objDeletePage.execute();

		var objWindows = this.objMediator.getEnumerator('navigator:browser');
		while (objWindows.hasMoreElements())
		{
			var objWindow = objWindows.getNext();

			try
			{
				var ndWindowBody, aWindows = objDogEar.GetOpenWindows(objWindow);
				for (var nWindow = 0; aWindows[nWindow]; ++nWindow)
				{
					if (aWindows[nWindow].location.href.replace(/#.*?((\?)|$)/, '$2') == sURL) objWindow.objDogEar.Reset(aWindows[nWindow].document.body);
				}
			}
			catch (sError)
			{
				continue;
			}
		}

		var nRowCount = this.GetRowCount();
		if (!nRowCount) return true;
		if (nRowCount == nIndex)
		{
			objDogEarTreeView.selection.select(nIndex - 1);
			return true;
		}

		objDogEarTreeView.selection.select(nIndex);

		return true;
	},

	DeleteAll: function()
	{
		if ((!this.objPrefs.prefHasUserValue('confirmremoveall') || this.objPrefs.getBoolPref('confirmremoveall')) && !confirm(this.objStringBundle.getString('dogears.removeall'))) return true;

		var objDogEar = this.GetDogEar();
		var nRowCount = this.GetRowCount();

		objDogEar.UpdateSidebarRowCount(0, nRowCount * -1);

		objDogEar.BeginTransaction();
		objDogEar.objTruncatePages.execute();

		objDogEar.BeginTransaction();
		objDogEar.objTruncateMarks.execute();

		var objWindows = this.objMediator.getEnumerator('navigator:browser');
		while (objWindows.hasMoreElements())
		{
			var objWindow = objWindows.getNext();

			try
			{
				if (!objWindow.objDogEar) continue;

				var ndWindowBody, aWindows = objDogEar.GetOpenWindows(objWindow);
				for (var nWindow = 0; aWindows[nWindow]; ++nWindow)
				{
					objWindow.objDogEar.Reset(aWindows[nWindow].document.body);
				}
			}
			catch (sError)
			{
				continue;
			}
		}

		return true;
	},

	Hide: function()
	{
		var objWindow = this.objMediator.getMostRecentWindow('navigator:browser');
		if (!objWindow.objDogEar)
		{
			return true;
		}

		objWindow.toggleSidebar('dogears-sidebar-bc');
		return true;
	},

	Click: function(e)
	{
		if (e.button > 1) return true;

		var objRow = {}, objColumn = {}, ndSource = {};
		objDogEarTreeView.treeBox.getCellAt(e.clientX, e.clientY, objRow, objColumn, ndSource);
		if (!ndSource.value || (ndSource.value == 'twisty')) return true;

		if (((e.button == 0) && e.ctrlKey) || (e.button == 1)) return objDogEarSidebar.OpenTab(objRow.value);
		if ((e.button == 0) && e.shiftKey) return objDogEarSidebar.OpenWindow(objRow.value);

		return objDogEarSidebar.Open(objRow.value);
	},

	Cancel: function(e)
	{
		e.preventDefault();
		e.stopPropagation();

		return false;
	},

	ContextMenu: function(e)
	{
		var bHideTreeItems = (objDogEarTreeView.selection.count == 0);
		var bHideDeleteAll = !objDogEarSidebar.GetRowCount();

		document.getElementById('dogears-sidebar-contextmenu-open').hidden = bHideTreeItems;
		document.getElementById('dogears-sidebar-contextmenu-openwindow').hidden = bHideTreeItems;
		document.getElementById('dogears-sidebar-contextmenu-opentab').hidden = bHideTreeItems;
		document.getElementById('dogears-sidebar-contextmenu-separator').hidden = bHideTreeItems;
		document.getElementById('dogears-sidebar-contextmenu-delete').hidden = bHideTreeItems;
		document.getElementById('dogears-sidebar-contextmenu-deleteall').hidden = bHideDeleteAll;
		document.getElementById('dogears-sidebar-contextmenu-deleteall-separator').hidden = bHideDeleteAll;

		return true;
	},

	Keypress: function(e)
	{
		if ((e.keyCode != 13) && (e.keyCode != 46)) return true;

		var nIndex = objDogEarTreeView.selection.currentIndex;
		if (nIndex < 0) return true;

		if (e.keyCode == 46) return objDogEarSidebar.Delete(nIndex);
		if (e.ctrlKey) return objDogEarSidebar.OpenTab(nIndex);
		if (e.shiftKey) return objDogEarSidebar.OpenWindow(nIndex);

		return objDogEarSidebar.Open(nIndex);
	},

	GetDogEar: function()
	{
		var objWindow = this.objMediator.getMostRecentWindow('navigator:browser');
		if (objWindow.objDogEar)
		{
			return objWindow.objDogEar;
		}

		return false;
	},

	GetRowCount: function()
	{
		var objDogEar = this.GetDogEar();
		var nRowCount = 0;

		try
		{
			objDogEar.BeginTransaction();
			if (objDogEar.objSelectCount.executeStep())
			{
				nRowCount = objDogEar.objSelectCount.getInt32(0);
			}
		}
		finally
		{
			if (objDogEar && objDogEar.objSelectCount && objDogEar.objSelectCount.reset) objDogEar.objSelectCount.reset();
		}

		return nRowCount;
	},

	GetRowCell: function(nRow, sColumnID)
	{
		var objData = null;
		var objDogEar = this.GetDogEar();
		var sSort = objDogEar.objPrefs.getCharPref('sidebarsort');

		try
		{
			objDogEar.BeginTransaction();
			objDogEar.objSelectSidebarRow[sSort].bindInt32Parameter(0, nRow);
			if (objDogEar.objSelectSidebarRow[sSort].executeStep())
			{
				objData = {};
				objData['sidebar-url'] = objDogEar.objSelectSidebarRow[sSort].getUTF8String(0);
				objData['sidebar-title'] = objDogEar.objSelectSidebarRow[sSort].getUTF8String(1);
				objData['sidebar-count'] = objDogEar.objSelectSidebarRow[sSort].getInt32(2);

				var objDate = new Date();
				objDate.setTime(objDogEar.objSelectSidebarRow[sSort].getInt64(3));
				objData['sidebar-latestdate'] = objDate.getPHPDate(objDogEarSidebar.objStringBundle.getString('dogears.statusbar.dateformat'));
			}
		}
		finally
		{
			if (objDogEar && objDogEar.objSelectSidebarRow && objDogEar.objSelectSidebarRow[sSort] && objDogEar.objSelectSidebarRow[sSort].reset) objDogEar.objSelectSidebarRow[sSort].reset();
		}

		return objData ? objData[sColumnID] : '';
	}
};

var objDogEarTreeView =
{
	selection: null,

	get rowCount()
	{
		return objDogEarSidebar.GetRowCount();
	},

	getCellText: function(nRow, ndColumn)
	{
		return objDogEarSidebar.GetRowCell(nRow, ((typeof(ndColumn) == 'string') ? ndColumn : ndColumn.id))
	},

	setTree: function(objTreeBox)
	{
		this.treeBox = objTreeBox;
	},

	cycleHeader: function(col, elem)
	{
		return false;
	},

	isContainer: function(row)
	{
		return false;
	},

	isSeparator: function(row)
	{
		return false;
	},

	isSorted: function()
	{
		return false;
	},

	getLevel: function(row)
	{
		return 0;
	},

	getImageSrc: function(row, col)
	{
		return null;
	},

	getParentIndex: function()
	{
		return false;
	},

	getRowProperties: function(row, props)
	{
		return false;
	},

	getCellProperties: function(row, col, props)
	{
		return false;
	},

	getColumnProperties: function(colid, col, props)
	{
		return false;
	},

	performAction: function(action)
	{
		return false;
	},

	performActionOnCell: function(action, index, column)
	{
		return false;
	}
};