var objDogEar =
{
	nContextMenuLeft: null,
	nContextMenuTop: null,
	ndContextMenuNode: null,
	ndContextMenuMarkNode: null,
	ndLastFocus: null,

	objDate: null,
	objDBService: null,
	objDBFile: null,
	objDBConnect: null,
	objStringBundle: null,
	bLocked: false,

	sUnit: 'px',

	objPrefs: Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefService).getBranch('extensions.dogears.'),

	Init: function(e)
	{
		objDogEar.objStringBundle = document.getElementById('dogears-string-bundle');

		window.removeEventListener('load', objDogEar.Init, false);

		if (!getBrowser || !getBrowser().browsers) return objDogEar.RemoveSidebar();
		var ndBrowser = getBrowser();

		window.addEventListener('unload', objDogEar.Destroy, false);
		window.addEventListener('close', objDogEar.Destroy, true);
		window.addEventListener('keypress', objDogEar.Keypress, false);

		ndBrowser.addEventListener('contextmenu', objDogEar.ContextMenu, true);
		ndBrowser.addEventListener('focus', objDogEar.StoreFocus, true);
		ndBrowser.addEventListener('mousedown', objDogEar.Click, false);
		ndBrowser.addEventListener('load', objDogEar.LoadMarks, true);

		document.getElementById('dogears-statusbar-popup').addEventListener('popupshowing', objDogEar.StatusBar, true);
		document.getElementById('dogears-statusbar-hbox').addEventListener('click', objDogEar.StatusBarClicked, true);
		document.getElementById('dogears-statusbar').hidden = (objDogEar.objPrefs.prefHasUserValue('statusbar') && !objDogEar.objPrefs.getBoolPref('statusbar'));

		objDogEar.objMediator = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService(Components.interfaces.nsIWindowMediator);

		if (!Components.interfaces.mozIStorageService) return objDogEar.RemoveSidebar();
		if (!Components.classes['@mozilla.org/storage/service;1']) return objDogEar.RemoveSidebar();

		objDogEar.objDBService = Components.classes['@mozilla.org/storage/service;1'].getService(Components.interfaces.mozIStorageService);
		objDogEar.objDBFile = Components.classes['@mozilla.org/file/directory_service;1'].getService(Components.interfaces.nsIProperties).get('ProfD', Components.interfaces.nsIFile);

		objDogEar.objDBFile.append('dogears_y5.sqlite');

		objDogEar.objDBConnect = objDogEar.objDBService.openDatabase(objDogEar.objDBFile);
		objDogEar.objDBConnect.executeSimpleSQL('CREATE TABLE IF NOT EXISTS dogear_pages (url TEXT PRIMARY KEY, title TEXT, next INTEGER, traverse INTEGER)');
		objDogEar.objDBConnect.executeSimpleSQL('CREATE TABLE IF NOT EXISTS dogear_marks (url TEXT, marknumber INTEGER, left INTEGER, top INTEGER, storedate INTEGER)');

		if (!objDogEar.objPrefs.prefHasUserValue('sidebarsort')) objDogEar.objPrefs.setCharPref('sidebarsort', 'latestdate_desc');

		objDogEar.BeginTransaction(objDogEar.objDBConnect.TRANSACTION_EXCLUSIVE);
		objDogEar.objSelectCount = objDogEar.objDBConnect.createStatement('SELECT COUNT(*) FROM dogear_pages');
		objDogEar.objSelectSidebarRow =
		{
			url: objDogEar.objDBConnect.createStatement('SELECT dp.url, dp.title, COUNT(dm.url) AS nummarks, MAX(dm.storedate) AS latestdate FROM dogear_pages dp, dogear_marks dm WHERE dp.url = dm.url GROUP BY dm.url ORDER BY dp.url LIMIT ?1, 1'),
			title: objDogEar.objDBConnect.createStatement('SELECT dp.url, dp.title, COUNT(dm.url) AS nummarks, MAX(dm.storedate) AS latestdate FROM dogear_pages dp, dogear_marks dm WHERE dp.url = dm.url GROUP BY dm.url ORDER BY dp.title LIMIT ?1, 1'),
			latestdate: objDogEar.objDBConnect.createStatement('SELECT dp.url, dp.title, COUNT(dm.url) AS nummarks, MAX(dm.storedate) AS latestdate FROM dogear_pages dp, dogear_marks dm WHERE dp.url = dm.url GROUP BY dm.url ORDER BY latestdate LIMIT ?1, 1'),
			count: objDogEar.objDBConnect.createStatement('SELECT dp.url, dp.title, COUNT(dm.url) AS nummarks, MAX(dm.storedate) AS latestdate FROM dogear_pages dp, dogear_marks dm WHERE dp.url = dm.url GROUP BY dm.url ORDER BY nummarks LIMIT ?1, 1'),

			url_desc: objDogEar.objDBConnect.createStatement('SELECT dp.url, dp.title, COUNT(dm.url) AS nummarks, MAX(dm.storedate) AS latestdate FROM dogear_pages dp, dogear_marks dm WHERE dp.url = dm.url GROUP BY dm.url ORDER BY dp.url DESC LIMIT ?1, 1'),
			title_desc: objDogEar.objDBConnect.createStatement('SELECT dp.url, dp.title, COUNT(dm.url) AS nummarks, MAX(dm.storedate) AS latestdate FROM dogear_pages dp, dogear_marks dm WHERE dp.url = dm.url GROUP BY dm.url ORDER BY dp.title DESC LIMIT ?1, 1'),
			latestdate_desc: objDogEar.objDBConnect.createStatement('SELECT dp.url, dp.title, COUNT(dm.url) AS nummarks, MAX(dm.storedate) AS latestdate FROM dogear_pages dp, dogear_marks dm WHERE dp.url = dm.url GROUP BY dm.url ORDER BY latestdate DESC LIMIT ?1, 1'),
			count_desc: objDogEar.objDBConnect.createStatement('SELECT dp.url, dp.title, COUNT(dm.url) AS nummarks, MAX(dm.storedate) AS latestdate FROM dogear_pages dp, dogear_marks dm WHERE dp.url = dm.url GROUP BY dm.url ORDER BY nummarks DESC LIMIT ?1, 1')
		};

		objDogEar.objSelectSidebarAll =
		{
			url: objDogEar.objDBConnect.createStatement('SELECT dp.url, dp.title, COUNT(dm.url) AS nummarks, MAX(dm.storedate) AS latestdate FROM dogear_pages dp, dogear_marks dm WHERE dp.url = dm.url GROUP BY dm.url ORDER BY dp.url'),
			title: objDogEar.objDBConnect.createStatement('SELECT dp.url, dp.title, COUNT(dm.url) AS nummarks, MAX(dm.storedate) AS latestdate FROM dogear_pages dp, dogear_marks dm WHERE dp.url = dm.url GROUP BY dm.url ORDER BY dp.title'),
			latestdate: objDogEar.objDBConnect.createStatement('SELECT dp.url, dp.title, COUNT(dm.url) AS nummarks, MAX(dm.storedate) AS latestdate FROM dogear_pages dp, dogear_marks dm WHERE dp.url = dm.url GROUP BY dm.url ORDER BY latestdate'),
			count: objDogEar.objDBConnect.createStatement('SELECT dp.url, dp.title, COUNT(dm.url) AS nummarks, MAX(dm.storedate) AS latestdate FROM dogear_pages dp, dogear_marks dm WHERE dp.url = dm.url GROUP BY dm.url ORDER BY nummarks'),

			url_desc: objDogEar.objDBConnect.createStatement('SELECT dp.url, dp.title, COUNT(dm.url) AS nummarks, MAX(dm.storedate) AS latestdate FROM dogear_pages dp, dogear_marks dm WHERE dp.url = dm.url GROUP BY dm.url ORDER BY dp.url DESC'),
			title_desc: objDogEar.objDBConnect.createStatement('SELECT dp.url, dp.title, COUNT(dm.url) AS nummarks, MAX(dm.storedate) AS latestdate FROM dogear_pages dp, dogear_marks dm WHERE dp.url = dm.url GROUP BY dm.url ORDER BY dp.title DESC'),
			latestdate_desc: objDogEar.objDBConnect.createStatement('SELECT dp.url, dp.title, COUNT(dm.url) AS nummarks, MAX(dm.storedate) AS latestdate FROM dogear_pages dp, dogear_marks dm WHERE dp.url = dm.url GROUP BY dm.url ORDER BY latestdate DESC'),
			count_desc: objDogEar.objDBConnect.createStatement('SELECT dp.url, dp.title, COUNT(dm.url) AS nummarks, MAX(dm.storedate) AS latestdate FROM dogear_pages dp, dogear_marks dm WHERE dp.url = dm.url GROUP BY dm.url ORDER BY nummarks DESC')
		};

		objDogEar.objSelectPage = objDogEar.objDBConnect.createStatement('SELECT url FROM dogear_pages WHERE url = ?1');
		objDogEar.objSelectMark = objDogEar.objDBConnect.createStatement('SELECT dm.marknumber, dm.left, dm.top, dp.next, dp.traverse FROM dogear_pages dp JOIN dogear_marks dm ON (dp.url = dm.url) WHERE dp.url = ?1 ORDER BY dm.storedate');
		objDogEar.objDeletePage = objDogEar.objDBConnect.createStatement('DELETE FROM dogear_pages WHERE url = ?1');
		objDogEar.objDeleteMark = objDogEar.objDBConnect.createStatement('DELETE FROM dogear_marks WHERE url = ?1 AND marknumber = ?2');
		objDogEar.objDeleteAllMarks = objDogEar.objDBConnect.createStatement('DELETE FROM dogear_marks WHERE url = ?1');
		objDogEar.objInsertPage = objDogEar.objDBConnect.createStatement('INSERT INTO dogear_pages VALUES (?1, ?2, ?3, ?4)');
		objDogEar.objInsertMark = objDogEar.objDBConnect.createStatement('INSERT INTO dogear_marks VALUES (?1, ?2, ?3, ?4, ?5)');
		objDogEar.objUpdatePage = objDogEar.objDBConnect.createStatement('UPDATE dogear_pages SET title = ?2, next = ?3 WHERE url = ?1');
		objDogEar.objUpdateTraverse = objDogEar.objDBConnect.createStatement('UPDATE dogear_pages SET traverse = ?2 WHERE url = ?1');
		objDogEar.objTruncatePages = objDogEar.objDBConnect.createStatement('DELETE FROM dogear_pages');
		objDogEar.objTruncateMarks = objDogEar.objDBConnect.createStatement('DELETE FROM dogear_marks');

		objDogEar.Commit();

		return true;
	},

	RemoveSidebar: function()
	{
		var aNodes = [];
		aNodes.push(document.getElementById('dogears-statusbar-sidebar-show'));
		aNodes.push(document.getElementById('dogears-statusbar-sidebar-hide'));
		aNodes.push(document.getElementById('dogears-contextmenu-sidebar-show'));
		aNodes.push(document.getElementById('dogears-contextmenu-sidebar-hide'));
		aNodes.push(document.getElementById('dogears-sidebar-view'));
		aNodes.push(document.getElementById('dogears-sidebar-bc'));

		for (var nNode = 0, nNumNodes = aNodes.length; nNode < nNumNodes; ++nNode)
		{
			if (aNodes[nNode] && aNodes[nNode].parentNode) aNodes[nNode].parentNode.removeChild(aNodes[nNode]);
		}

		return true;
	},

	Destroy: function(e)
	{
		if (objDogEar.objDBService) objDogEar.Commit();

		var ndBrowser = getBrowser();

		window.removeEventListener('unload', objDogEar.Destroy, false);
		window.removeEventListener('close', objDogEar.Destroy, true);
		window.removeEventListener('keypress', objDogEar.Keypress, false);

		ndBrowser.removeEventListener('contextmenu', objDogEar.ContextMenu, true);
		ndBrowser.removeEventListener('focus', objDogEar.StoreFocus, true);
		ndBrowser.removeEventListener('mousedown', objDogEar.Click, false);
		ndBrowser.removeEventListener('load', objDogEar.LoadMarks, true);

		document.getElementById('dogears-statusbar-popup').removeEventListener('popupshowing', objDogEar.StatusBar, true);
		document.getElementById('dogears-statusbar-hbox').removeEventListener('click', objDogEar.StatusBarClicked, true);

		return true;
	},

	GetLockedWindow: function()
	{
		var objWindows = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService(Components.interfaces.nsIWindowMediator).getEnumerator('navigator:browser');
		while (objWindows.hasMoreElements())
		{
			var objWindow = objWindows.getNext();
			if (objWindow.objDogEar && objWindow.objDogEar.bLocked) return objWindow;
		}

		return false;
	},

	UnlockWindows: function()
	{
		var objWindows = objDogEar.objMediator.getEnumerator('navigator:browser');
		while (objWindows.hasMoreElements())
		{
			var objWindow = objWindows.getNext();
			if (objWindow.objDogEar) objWindow.objDogEar.bLocked = false;
		}

		return true;
	},

	BeginTransaction: function()
	{
		if (objDogEar.bLocked) return true;

		objDogEar.Commit();
		objDogEar.bLocked = true;

		var nType = arguments.length ? arguments[0] : objDogEar.objDBConnect.TRANSACTION_DEFERRED;
		objDogEar.objDBConnect.beginTransactionAs(nType);

		return true;
	},

	Commit: function()
	{
		var objWindow = objDogEar.GetLockedWindow();
		if (!objWindow && objDogEar.objDBConnect.transactionInProgress) objDogEar.objDBConnect.commitTransaction();
		if (objWindow && objWindow.objDogEar.objDBConnect.transactionInProgress) objWindow.objDogEar.objDBConnect.commitTransaction();

		objDogEar.UnlockWindows();
		return true;
	},

	GetParentNodes: function(ndNode)
	{
		var aParents = [];
		while (ndNode.nodeName.toLowerCase() != '#document')
		{
			aParents.push(ndNode);
			ndNode = ndNode.parentNode;
		}

		return aParents;
	},

	IsParent: function(ndNode, aCandidates)
	{
		var objParents = {};
		while (ndNode.nodeName.toLowerCase() != '#document')
		{
			objParents[ndNode.nodeName.toLowerCase()] = true;
			ndNode = ndNode.parentNode;
		}

		for (var nCandidate = 0; aCandidates[nCandidate] !== undefined; ++nCandidate)
		{
			if (objParents[aCandidates[nCandidate]]) return true;
		}

		return false;
	},

	LoadMarks: function(e)
	{
		var ndDocument = e.originalTarget;
		var ndWindow = ndDocument.defaultView;
		var ndBody = ndDocument.body;
		if (!ndBody) return true;

		var sLocation = ndWindow.location.href.replace(/#.*?((\?)|$)/, '$2');

		if (objDogEar.objDBService) return objDogEar.Load(ndBody);

		var objWindows = objDogEar.objMediator.getEnumerator('navigator:browser');
		while (objWindows.hasMoreElements())
		{
			var objWindow = objWindows.getNext();

			try
			{
				var ndWindowBody, aWindows = objDogEar.GetOpenWindows(objWindow);
				for (var nWindow = 0; aWindows[nWindow]; ++nWindow)
				{
					if ((aWindows[nWindow] != ndWindow) && (aWindows[nWindow].location.href.replace(/#.*?((\?)|$)/, '$2') == sLocation))
					{
						ndWindowBody = aWindows[nWindow].document.body;
						ndBody.setAttribute('dogear_list', ndWindowBody.getAttribute('dogear_list'));
						ndBody.setAttribute('dogear_coordinates', ndWindowBody.getAttribute('dogear_coordinates'));
						ndBody.setAttribute('dogear_next', ndWindowBody.getAttribute('dogear_next'));
						ndBody.setAttribute('dogear_traverse_current', ndWindowBody.getAttribute('dogear_traverse_current'));

						var aDogEarList = ndBody.getAttribute('dogear_list').length ? ndBody.getAttribute('dogear_list').split(',') : [];
						var aDogEarCoordinates = ndBody.getAttribute('dogear_coordinates').length ? ndBody.getAttribute('dogear_coordinates').split(',') : [];

						for (var nMark = 0; aDogEarList[nMark]; ++nMark)
						{
							objDogEar.AddMark(ndBody, aDogEarList[nMark], parseInt(aDogEarCoordinates[nMark].split('|')[0], 10), parseInt(aDogEarCoordinates[nMark].split('|')[1], 10));
						}

						return true;
					}
				}
			}
			catch (sError)
			{
				continue;
			}
		}

		return true;
	},

	Load: function(ndNode)
	{
		var ndDocument = ndNode.ownerDocument;
		var ndWindow = ndDocument.defaultView;
		var ndBody = ndDocument.body;
		if (!ndBody) return true;

		this.Reset(ndNode);
		objData = this.GetData(ndWindow.location.href.replace(/#.*?((\?)|$)/, '$2'));
		if (!objData) return true;

		ndBody.setAttribute('dogear_list', objData['dogear_list']);
		ndBody.setAttribute('dogear_coordinates', objData['dogear_coordinates']);
		ndBody.setAttribute('dogear_next', objData['dogear_next']);
		ndBody.setAttribute('dogear_traverse_current', objData['dogear_traverse_current']);

		var aDogEarList = objData['dogear_list'].length ? objData['dogear_list'].split(',') : [];
		var aDogEarCoordinates = objData['dogear_coordinates'].length ? objData['dogear_coordinates'].split(',') : [];
		var nTraverse = parseInt(objData['dogear_traverse_current'], 10);

		for (var nMark = 0; aDogEarList[nMark]; ++nMark)
		{
			this.AddMark(ndNode, aDogEarList[nMark], parseInt(aDogEarCoordinates[nMark].split('|')[0], 10), parseInt(aDogEarCoordinates[nMark].split('|')[1], 10));
		}

		if ((nTraverse >= 0) && this.objPrefs.prefHasUserValue('lastviewed') && this.objPrefs.getBoolPref('lastviewed')) ndWindow.scrollTo(parseInt(aDogEarCoordinates[nTraverse].split('|')[0], 10) - 30, parseInt(aDogEarCoordinates[nTraverse].split('|')[1], 10) - 30);
		ndWindow.focus();

		return true;
	},

	GetData: function(sLocation)
	{
		var aList = [];
		var aCoordinates = [];
		var nNext = 0;
		var nCurrent = -1;

		try
		{
			this.BeginTransaction();
			this.objSelectMark.bindUTF8StringParameter(0, sLocation);
			while (this.objSelectMark.executeStep())
			{
				aList.push(this.objSelectMark.getInt32(0));
				aCoordinates.push(this.objSelectMark.getInt32(1) + this.sUnit + '|' + this.objSelectMark.getInt32(2) + this.sUnit);
				nNext = this.objSelectMark.getInt32(3);
				nCurrent = this.objSelectMark.getInt32(4);
			}
		}
		finally
		{
			if (this.objSelectMark && this.objSelectMark.reset) this.objSelectMark.reset();
		}

		var objData = {
			'dogear_list': aList.join(','),
			'dogear_coordinates': aCoordinates.join(','),
			'dogear_next': nNext + '',
			'dogear_traverse_current': nCurrent + ''
		};

		return aList.length ? objData : null;
	},

	AddMark: function(ndNode, nDogEar, nLeft, nTop)
	{
		if (document.getElementById('dogears-toolbar-move')) document.getElementById('dogears-toolbar-move').disabled = false;
		if (document.getElementById('dogears-toolbar-clear')) document.getElementById('dogears-toolbar-clear').disabled = false;

		var ndDocument = ndNode.ownerDocument;
		var ndWindow = ndDocument.defaultView;
		var ndBody = ndDocument.body;
		if (!ndBody) return true;

		var ndDiv = ndDocument.createElement('div');
		ndDiv.id = 'dogear-y5-' + nDogEar;
		ndDiv.className = 'dogear-y5';
		ndDiv.style.left = nLeft + this.sUnit;
		ndDiv.style.top = nTop + this.sUnit;
		ndDiv.style.width = '32' + this.sUnit;
		ndDiv.style.height = '21' + this.sUnit;
		ndDiv.style.paddingTop = '14' + this.sUnit;
		ndDiv.style.background = 'url("chrome://dogears/skin/dogears-bg.png") no-repeat left top';
		ndDiv.style.color = '#000000';
		ndDiv.style.zIndex = '55555';
		ndDiv.style.cursor = 'default';
		ndDiv.style.position = 'absolute';
		ndDiv.style.fontFamily = 'sans-serif';
		ndDiv.style.fontSize = '14' + this.sUnit;
		ndDiv.style.fontWeight = 'bold';
		ndDiv.style.textAlign = 'center';
		ndDiv.style.opacity = '.8';

		ndDiv.appendChild(ndDocument.createTextNode(nDogEar + ''));
		ndBody.appendChild(ndDiv);

		return true;
	},

	Mark: function(ndNode, nLeft, nTop)
	{
		var ndDocument = ndNode.ownerDocument;
		var ndBody = ndDocument.body;
		if (!ndBody) return true;

		var ndWindow = ndDocument.defaultView;
		var sLocation = ndWindow.location.href.replace(/#.*?((\?)|$)/, '$2');

		nLeft = (nLeft - 16);
		nTop = (nTop - 17);

		var aDogEarList = ndBody.getAttribute('dogear_list').length ? ndBody.getAttribute('dogear_list').split(',') : [];
		var aDogEarCoordinates = ndBody.getAttribute('dogear_coordinates').length ? ndBody.getAttribute('dogear_coordinates').split(',') : [];
		var nNewDogEar = parseInt(ndBody.getAttribute('dogear_next'), 10);

		aDogEarList.push(nNewDogEar);
		aDogEarCoordinates.push(nLeft + this.sUnit + '|' + nTop + this.sUnit);

		var objWindows = this.objMediator.getEnumerator('navigator:browser');
		while (objWindows.hasMoreElements())
		{
			var objWindow = objWindows.getNext();

			try
			{
				var ndWindowBody, aWindows = this.GetOpenWindows(objWindow);

				for (var nWindow = 0; aWindows[nWindow]; ++nWindow)
				{
					if (aWindows[nWindow].location.href.replace(/#.*?((\?)|$)/, '$2') == sLocation)
					{
						ndWindowBody = aWindows[nWindow].document.body;
						ndWindowBody.setAttribute('dogear_list', aDogEarList.join(','));
						ndWindowBody.setAttribute('dogear_coordinates', aDogEarCoordinates.join(','));
						ndWindowBody.setAttribute('dogear_next', (nNewDogEar + 1) + '');

						objWindow.objDogEar.AddMark(ndWindowBody, nNewDogEar, nLeft, nTop);
					}
				}
			}
			catch (sError)
			{
				continue;
			}
		}

		if (this.objDBService)
		{
			this.objDate = new Date();
			var sTitle = ndWindow.document.title ? ndWindow.document.title : sLocation;

			try
			{
				this.BeginTransaction();
				this.objSelectPage.bindUTF8StringParameter(0, sLocation);
				if (this.objSelectPage.executeStep())
				{
					this.objSelectPage.reset();

					this.BeginTransaction();
					this.objUpdatePage.bindUTF8StringParameter(0, sLocation);
					this.objUpdatePage.bindUTF8StringParameter(1, sTitle);
					this.objUpdatePage.bindInt32Parameter(2, nNewDogEar + 1);
					this.objUpdatePage.execute();

					var nIndex = this.GetSidebarIndex(sLocation);
					this.UpdateSidebarRows(nIndex);
				}
				else
				{
					this.objSelectPage.reset();

					this.BeginTransaction();
					this.objInsertPage.bindUTF8StringParameter(0, sLocation);
					this.objInsertPage.bindUTF8StringParameter(1, sTitle);
					this.objInsertPage.bindInt32Parameter(2, nNewDogEar + 1);
					this.objInsertPage.bindInt32Parameter(3, -1);
					this.objInsertPage.execute();

					this.UpdateSidebarRowCount(0, 1);
				}
			}
			finally
			{
				if (this.objSelectPage && this.objSelectPage.reset) this.objSelectPage.reset();
			}

			this.BeginTransaction();
			this.objDeleteMark.bindUTF8StringParameter(0, sLocation);
			this.objDeleteMark.bindInt32Parameter(1, nNewDogEar);
			this.objDeleteMark.execute();

			this.BeginTransaction();
			this.objInsertMark.bindUTF8StringParameter(0, sLocation);
			this.objInsertMark.bindInt32Parameter(1, nNewDogEar);
			this.objInsertMark.bindInt32Parameter(2, nLeft);
			this.objInsertMark.bindInt32Parameter(3, nTop);
			this.objInsertMark.bindInt64Parameter(4, this.objDate.getTime());
			this.objInsertMark.execute();
		}

		ndWindow.focus();
		return true;
	},

	Unmark: function(ndNode, ndMarked)
	{
		var ndDocument = ndNode.ownerDocument;
		var ndBody = ndDocument.body;
		if (!ndBody) return true;

		var ndWindow = ndDocument.defaultView;
		var sLocation = ndWindow.location.href.replace(/#.*?((\?)|$)/, '$2');

		var aDogEarList = ndBody.getAttribute('dogear_list').length ? ndBody.getAttribute('dogear_list').split(',') : [];
		var aDogEarCoordinates = ndBody.getAttribute('dogear_coordinates').length ? ndBody.getAttribute('dogear_coordinates').split(',') : [];
		var nTraverse = parseInt(ndBody.getAttribute('dogear_traverse_current'), 10);

		var nDogEarID = parseInt(ndMarked.id.substring('dogear-y5-'.length), 10);
		var nIndex = aDogEarList.indexOf(nDogEarID + '');

		aDogEarList.splice(nIndex, 1);
		aDogEarCoordinates.splice(nIndex, 1);
		if (nIndex <= nTraverse) --nTraverse;

		var objWindows = this.objMediator.getEnumerator('navigator:browser');
		while (objWindows.hasMoreElements())
		{
			var objWindow = objWindows.getNext();

			try
			{
				var ndWindowBody, aWindows = this.GetOpenWindows(objWindow);
				for (var nWindow = 0; aWindows[nWindow]; ++nWindow)
				{
					if (aWindows[nWindow].location.href.replace(/#.*?((\?)|$)/, '$2') == sLocation)
					{
						ndWindowBody = aWindows[nWindow].document.body;
						ndWindowBody.removeChild(aWindows[nWindow].document.getElementById(ndMarked.id));
						ndWindowBody.setAttribute('dogear_list', aDogEarList.join(','));
						ndWindowBody.setAttribute('dogear_coordinates', aDogEarCoordinates.join(','));
						ndWindowBody.setAttribute('dogear_traverse_current', nTraverse + '');

						if (!aDogEarList.length) objWindow.objDogEar.Reset(ndWindowBody);
					}
				}
			}
			catch (sError)
			{
				continue;
			}
		}

		if (this.objDBService)
		{
			nIndex = this.GetSidebarIndex(sLocation);

			this.BeginTransaction();
			this.objDeleteMark.bindUTF8StringParameter(0, sLocation);
			this.objDeleteMark.bindInt32Parameter(1, nDogEarID);
			this.objDeleteMark.execute();

			this.BeginTransaction();
			this.objUpdateTraverse.bindUTF8StringParameter(0, sLocation);
			this.objUpdateTraverse.bindInt32Parameter(1, nTraverse);
			this.objUpdateTraverse.execute();

			this.UpdateSidebarRows(nIndex);
			if (!aDogEarList.length)
			{
				if (nIndex !== false) this.UpdateSidebarRowCount(nIndex, -1);

				this.BeginTransaction();
				this.objDeleteAllMarks.bindUTF8StringParameter(0, sLocation);
				this.objDeleteAllMarks.execute();

				this.BeginTransaction();
				this.objDeletePage.bindUTF8StringParameter(0, sLocation);
				this.objDeletePage.execute();
			}
		}

		ndWindow.focus();
		return true;
	},

	Clear: function(ndNode)
	{
		var ndDocument = ndNode.ownerDocument;
		var ndBody = ndDocument.body;
		if (!ndBody) return true;

		var ndWindow = ndDocument.defaultView;
		var sLocation = ndWindow.location.href.replace(/#.*?((\?)|$)/, '$2');

		var objWindows = this.objMediator.getEnumerator('navigator:browser');
		while (objWindows.hasMoreElements())
		{
			var objWindow = objWindows.getNext();

			try
			{
				var aWindows = this.GetOpenWindows(objWindow);
				for (var nWindow = 0; aWindows[nWindow]; ++nWindow)
				{
					if (aWindows[nWindow].location.href.replace(/#.*?((\?)|$)/, '$2') == sLocation) objWindow.objDogEar.Reset(aWindows[nWindow].document.body);
				}
			}
			catch (sError)
			{
				continue;
			}
		}

		if (this.objDBService)
		{
			var nIndex = this.GetSidebarIndex(sLocation);
			if (nIndex !== false) this.UpdateSidebarRowCount(nIndex, -1);

			this.BeginTransaction();
			this.objDeleteAllMarks.bindUTF8StringParameter(0, sLocation);
			this.objDeleteAllMarks.execute();

			this.BeginTransaction();
			this.objDeletePage.bindUTF8StringParameter(0, sLocation);
			this.objDeletePage.execute();
		}

		ndWindow.focus();
		return true;
	},

	Traverse: function(ndNode)
	{
		var ndDocument = ndNode.ownerDocument;
		var ndWindow = ndDocument.defaultView;
		var ndBody = ndDocument.body;
		if (!ndBody) return true;

		var sLocation = ndWindow.location.href.replace(/#.*?((\?)|$)/, '$2');

		var aDogEarCoordinates = ndBody.getAttribute('dogear_coordinates').length ? ndBody.getAttribute('dogear_coordinates').split(',') : [];
		var nTraverse = parseInt(ndBody.getAttribute('dogear_traverse_current'), 10) + 1;

		if (!aDogEarCoordinates.length) return false;
		if (nTraverse >= aDogEarCoordinates.length) nTraverse = 0;

		ndBody.setAttribute('dogear_traverse_current', nTraverse + '');

		if (this.objDBService)
		{
			this.BeginTransaction();
			this.objUpdateTraverse.bindUTF8StringParameter(0, sLocation);
			this.objUpdateTraverse.bindInt32Parameter(1, nTraverse);
			this.objUpdateTraverse.execute();
		}

		ndWindow.scrollTo(parseInt(aDogEarCoordinates[nTraverse].split('|')[0], 10) - 30, parseInt(aDogEarCoordinates[nTraverse].split('|')[1], 10) - 30);

		return true;
	},

	Reset: function(ndNode)
	{
		if (document.getElementById('dogears-toolbar-move')) document.getElementById('dogears-toolbar-move').disabled = true;
		if (document.getElementById('dogears-toolbar-clear')) document.getElementById('dogears-toolbar-clear').disabled = true;

		var ndDocument = ndNode.ownerDocument;
		var ndBody = ndDocument.body;
		if (!ndBody) return true;

		if (ndBody.getAttribute('dogear_list'))
		{
			var aDogEarList = ndBody.getAttribute('dogear_list').length ? ndBody.getAttribute('dogear_list').split(',') : [];

			var ndMarked;
			for (var nMark = 0; aDogEarList[nMark]; ++nMark)
			{
				ndMarked = ndDocument.getElementById('dogear-y5-' + aDogEarList[nMark]);
				ndBody.removeChild(ndMarked);
			}
		}

		ndBody.setAttribute('dogear_list', '');
		ndBody.setAttribute('dogear_coordinates', '');
		ndBody.setAttribute('dogear_next', '1');
		ndBody.setAttribute('dogear_traverse_current', '-1');

		return true;
	},

	Click: function(e)
	{
		if (objDogEar.objPrefs.prefHasUserValue('shortcutmark') && !objDogEar.objPrefs.getBoolPref('shortcutmark')) return true;

		var ndNode = e.explicitOriginalTarget || e.originalTarget;

		if (!e.shiftKey || (e.button == 2)) return true;
		if (ndNode.nodeName.match(/^xul/)) return true;
		if (objDogEar.IsParent(ndNode, ['a', 'input', 'textarea', 'select'])) return true;

		var ndDocument = ndNode.ownerDocument;
		var ndBody = ndDocument.body;
		if (!ndBody) return true;

		if (!ndBody.getAttribute('dogear_next')) objDogEar.Clear(ndNode);

		var aParentNodes = objDogEar.GetParentNodes(ndNode);
		for (var nNode = 0; aParentNodes[nNode]; ++nNode)
		{
			if (aParentNodes[nNode].className == 'dogear-y5')
			{
				objDogEar.Unmark(ndNode, aParentNodes[nNode]);

				e.preventDefault();
				e.stopPropagation();
				return false;
			}
		}

		if (ndNode.nodeName.match(/^#text/)) return true;
		objDogEar.Mark(ndNode, e.pageX, e.pageY);

		e.preventDefault();
		e.stopPropagation();
		return false;
	},

	Keypress: function(e)
	{
		var ndNode = e.originalTarget;

		if ((e.charCode != 32) && (e.keyCode != 32) && (e.charCode != 68) && (e.keyCode != 68) && (e.charCode != 100) && (e.keyCode != 100) && (e.charCode != 69) && (e.keyCode != 69) && (e.charCode != 101) && (e.keyCode != 101)) return true;

		if ((e.charCode == 68) || (e.keyCode == 68) || (e.charCode == 100) || (e.keyCode == 100))
		{
			if (!objDogEar.objDBService) return true;
			if (objDogEar.objPrefs.prefHasUserValue('shortcutsidebar') && !objDogEar.objPrefs.getBoolPref('shortcutsidebar')) return true;
			if (e.ctrlKey && e.shiftKey) toggleSidebar('dogears-sidebar-bc');

			return true;
		}

		var ndDocument = ndNode.ownerDocument;
		var ndBody = ndDocument.body;
		if (!ndBody) return true;

		if (!ndBody.getAttribute('dogear_next')) objDogEar.Clear(ndNode);

		if ((e.charCode == 32) || (e.keyCode == 32))
		{
			if (e.ctrlKey && e.shiftKey)
			{
				var aDogEarList = ndBody.getAttribute('dogear_list').length ? ndBody.getAttribute('dogear_list').split(',') : [];

				if (!aDogEarList.length) return true;
				if (objDogEar.objPrefs.prefHasUserValue('shortcutclear') && !objDogEar.objPrefs.getBoolPref('shortcutclear')) return true;

				var bConfirm = (!objDogEar.objPrefs.prefHasUserValue('confirmremovepage') || objDogEar.objPrefs.getBoolPref('confirmremovepage'));
				if (!bConfirm || (bConfirm && confirm(objDogEar.objStringBundle.getString('dogears.removepage')))) objDogEar.Clear(ndNode);

				e.preventDefault();
				e.stopPropagation();
				return false;
			}

			if (e.shiftKey)
			{
				if (objDogEar.objPrefs.prefHasUserValue('shortcutmove') && !objDogEar.objPrefs.getBoolPref('shortcutmove')) return true;
				if (objDogEar.Traverse(ndNode))
				{
					e.preventDefault();
					e.stopPropagation();
					return false;
				}
			}
		}

		if (e.ctrlKey && e.shiftKey && ((e.charCode == 69) || (e.keyCode == 69) || (e.charCode == 101) || (e.keyCode == 101)))
		{
			if (objDogEar.objPrefs.prefHasUserValue('shortcutkeyboardmark') && !objDogEar.objPrefs.getBoolPref('shortcutkeyboardmark')) return true;

			var aDogEarList = ndBody.getAttribute('dogear_list').length ? ndBody.getAttribute('dogear_list').split(',') : [];
			var aDogEarCoordinates = ndBody.getAttribute('dogear_coordinates').length ? ndBody.getAttribute('dogear_coordinates').split(',') : [];
			var nIndex = aDogEarCoordinates.indexOf((ndDocument.defaultView.scrollX + 10) + objDogEar.sUnit + '|' + (ndDocument.defaultView.scrollY + 10) + objDogEar.sUnit);

			if (nIndex > -1)
			{
				if (objDogEar.Unmark(ndBody, ndDocument.getElementById('dogear-y5-' + aDogEarList[nIndex])))
				{
					e.preventDefault();
					e.stopPropagation();
					return false;
				}
			}
			else if (objDogEar.Mark(ndBody, ndDocument.defaultView.scrollX + 26, ndDocument.defaultView.scrollY + 27))
			{
				e.preventDefault();
				e.stopPropagation();
				return false;
			}
		}

		return true;
	},

	StoreFocus: function(e)
	{
		var ndNode = e.explicitOriginalTarget || e.originalTarget;
		if (!ndNode || !ndNode.ownerDocument || !ndNode.nodeName || ndNode.nodeName.match(/^xul/)) return true;

		objDogEar.ndLastFocus = ndNode;

		return true;
	},

	Options: function()
	{
		window.openDialog('chrome://dogears/content/dogears-options.xul', 'dogearsOptions', 'centerscreen,chrome,modal');

		return true;
	},

	StatusBarClicked: function(e)
	{
		if (e.button == 0) objDogEar.ButtonTraverse();

		return true;
	},


	StatusBar: function(e)
	{
		if (document.getElementById('dogears-statusbar-sidebar-show')) document.getElementById('dogears-statusbar-sidebar-show').hidden = true;
		if (document.getElementById('dogears-statusbar-sidebar-hide')) document.getElementById('dogears-statusbar-sidebar-hide').hidden = true;
		document.getElementById('dogears-statusbar-move').hidden = true;
		document.getElementById('dogears-statusbar-clear').hidden = true;
		document.getElementById('dogears-statusbar-separator').hidden = true;

		if (!objDogEar.ndLastFocus) return true;
		var ndDocument = objDogEar.ndLastFocus.ownerDocument;
		var ndBody = ndDocument.body;
		if (!ndBody) return true;

		if (!ndBody.getAttribute('dogear_next')) objDogEar.Clear(objDogEar.ndLastFocus);

		if (objDogEar.objDBService)
		{
			var ndSidebar = objDogEar.GetSidebar();
			document.getElementById('dogears-statusbar-sidebar-show').hidden = (ndSidebar != null);
			document.getElementById('dogears-statusbar-sidebar-hide').hidden = (ndSidebar == null);
		}

		var aDogEarList = ndBody.getAttribute('dogear_list').length ? ndBody.getAttribute('dogear_list').split(',') : [];
		if (aDogEarList.length)
		{
			document.getElementById('dogears-statusbar-move').hidden = false;
			document.getElementById('dogears-statusbar-clear').hidden = false;
			document.getElementById('dogears-statusbar-separator').hidden = false;
		}

		return true;
	},

	ContextMenu: function(e)
	{
		if (document.getElementById('dogears-contextmenu-sidebar-show')) document.getElementById('dogears-contextmenu-sidebar-show').hidden = true;
		if (document.getElementById('dogears-contextmenu-sidebar-hide')) document.getElementById('dogears-contextmenu-sidebar-hide').hidden = true;
		document.getElementById('dogears-contextmenu').hidden = true;
		document.getElementById('dogears-contextmenu-mark').hidden = true;
		document.getElementById('dogears-contextmenu-unmark').hidden = true;
		document.getElementById('dogears-contextmenu-move').hidden = true;
		document.getElementById('dogears-contextmenu-clear').hidden = true;

		if (objDogEar.objPrefs.prefHasUserValue('contextmenu') && !objDogEar.objPrefs.getBoolPref('contextmenu')) return true;

		var ndNode = e.explicitOriginalTarget || e.originalTarget;
		if (ndNode.nodeName.match(/^xul/)) return true;
		if (objDogEar.IsParent(ndNode, ['input', 'textarea', 'select'])) return true;

		objDogEar.ndContextMenuNode = ndNode;
		objDogEar.ndContextMenuMarkNode = null;
		objDogEar.nContextMenuLeft = e.pageX;
		objDogEar.nContextMenuTop = e.pageY;

		var ndDocument = objDogEar.ndContextMenuNode.ownerDocument;
		var ndBody = ndDocument.body;
		if (!ndBody) return true;

		if (!ndBody.getAttribute('dogear_next')) objDogEar.Clear(objDogEar.ndContextMenuNode);

		document.getElementById('dogears-contextmenu').hidden = false;

		if (objDogEar.objDBService)
		{
			var ndSidebar = objDogEar.GetSidebar();
			document.getElementById('dogears-contextmenu-sidebar-show').hidden = (ndSidebar != null);
			document.getElementById('dogears-contextmenu-sidebar-hide').hidden = (ndSidebar == null);
		}

		var aDogEarList = ndBody.getAttribute('dogear_list').length ? ndBody.getAttribute('dogear_list').split(',') : [];
		if (aDogEarList.length)
		{
			document.getElementById('dogears-contextmenu-move').hidden = false;
			document.getElementById('dogears-contextmenu-clear').hidden = false;
		}

		var aParentNodes = objDogEar.GetParentNodes(objDogEar.ndContextMenuNode);
		for (var nNode = 0; aParentNodes[nNode]; ++nNode)
		{
			if (aParentNodes[nNode].className == 'dogear-y5')
			{
				objDogEar.ndContextMenuMarkNode = aParentNodes[nNode];
				document.getElementById('dogears-contextmenu-unmark').hidden = false;

				return true;
			}
		}

		document.getElementById('dogears-contextmenu-mark').hidden = false;

		return true;
	},

	ContextMenuMark: function()
	{
		if (objDogEar.ndContextMenuMarkNode)
		{
			objDogEar.Unmark(objDogEar.ndContextMenuNode, objDogEar.ndContextMenuMarkNode);
		}
		else
		{
			objDogEar.Mark(objDogEar.ndContextMenuNode, objDogEar.nContextMenuLeft, objDogEar.nContextMenuTop);
		}

		return true;
	},

	ButtonTraverse: function()
	{
		if (!objDogEar.ndLastFocus) return true;
		var ndDocument = objDogEar.ndLastFocus.ownerDocument;
		var ndBody = ndDocument.body;
		if (!ndBody) return true;

		if (!ndBody.getAttribute('dogear_next')) objDogEar.Clear(objDogEar.ndLastFocus);

		objDogEar.Traverse(objDogEar.ndLastFocus);

		return true;
	},

	ButtonClear: function(e)
	{
		if (!objDogEar.ndLastFocus) return true;
		var ndDocument = objDogEar.ndLastFocus.ownerDocument;
		var ndBody = ndDocument.body;
		if (!ndBody) return true;

		var bConfirm = (!objDogEar.objPrefs.prefHasUserValue('confirmremovepage') || objDogEar.objPrefs.getBoolPref('confirmremovepage'));
		if (!bConfirm || (bConfirm && confirm(objDogEar.objStringBundle.getString('dogears.removepage')))) objDogEar.Clear(objDogEar.ndLastFocus);

		return true;
	},

	GetOpenWindows: function(objWindow)
	{
		var aOpenWindows = [];

		if (!objWindow.objDogEar) return aOpenWindows;

		var objBrowser = objWindow.getBrowser();
		for (var nTab = 0; objBrowser.browsers[nTab]; ++nTab)
		{
			aOpenWindows = aOpenWindows.concat(this.GetFramesRecursive(objBrowser.browsers[nTab].contentWindow));
		}

		return aOpenWindows;
	},

	GetFramesRecursive: function(objWindow)
	{
		var aWindows = [];

		if ((objWindow == objWindow.top) && objWindow.document && objWindow.document.body) aWindows.push(objWindow);

		for (var nFrame = 0; objWindow.frames[nFrame]; ++nFrame)
		{
			if (objWindow.document && objWindow.document.body) aWindows.push(objWindow.frames[nFrame]);
			if (objWindow.frames[nFrame].frames.length) aWindows = aWindows.concat(this.GetFramesRecursive(objWindow.frames[nFrame]));
		}

		return aWindows;
	},

	UpdateSidebarRows: function(nIndex)
	{
		if (nIndex === false) return false;

		var objWindows = objDogEar.objMediator.getEnumerator('navigator:browser');
		while (objWindows.hasMoreElements())
		{
			var objWindow = objWindows.getNext();

			try
			{
				if (!objWindow.objDogEar) continue;

				var ndSidebar = objWindow.document.getElementById('sidebar');
				var ndTreeView = ndSidebar.contentWindow.objDogEarTreeView;

				if (!ndTreeView) continue;

				for (var nAll = nIndex; nAll >= 0; --nAll)
				{
					ndTreeView.treeBox.invalidateRow(nAll);
				}
			}
			catch (sError)
			{
				continue;
			}
		}

		return true;
	},

	UpdateSidebarRowCount: function(nIndex, nRows)
	{
		var objWindows = objDogEar.objMediator.getEnumerator('navigator:browser');
		while (objWindows.hasMoreElements())
		{
			try
			{
				var objWindow = objWindows.getNext();
				if (!objWindow.objDogEar) continue;

				var ndSidebar = objWindow.document.getElementById('sidebar');
				var ndTreeView = ndSidebar.contentWindow.objDogEarTreeView;

				if (!ndTreeView) continue;

				ndTreeView.treeBox.rowCountChanged(nIndex, nRows);
			}
			catch (sError)
			{
				continue;
			}
		}

		return true;
	},

	GetSidebar: function()
	{
		try
		{
			var ndSidebar = document.getElementById('sidebar');
			var ndTreeView = ndSidebar.contentWindow.objDogEarTreeView;
			if (!ndTreeView) return null;

			return ndSidebar;
		}
		catch (sError)
		{
		}

		return null;
	},

	GetSidebarIndex: function(sLocation)
	{
		try
		{
			var nIndex = 0;
			var sSort = this.objPrefs.getCharPref('sidebarsort');

			this.BeginTransaction();
			while (this.objSelectSidebarAll[sSort].executeStep())
			{
				if (sLocation == this.objSelectSidebarAll[sSort].getUTF8String(0))
				{
					this.objSelectSidebarAll[sSort].reset();
					return nIndex;
				}

				++nIndex;
			}
		}
		finally
		{
			if (this.objSelectSidebarAll && this.objSelectSidebarAll[sSort] && this.objSelectSidebarAll[sSort].reset) this.objSelectSidebarAll[sSort].reset();
		}

		return false;
	}
};

if (!Array.prototype.indexOf)
{
	Array.prototype.indexOf = function(objFind)
	{
		var nLength = this.length;

		var nOffset = Number(arguments[1]) || 0;
		nOffset = (nOffset < 0) ? Math.ceil(nOffset) : Math.floor(nOffset);
		if (nOffset < 0) nOffset += nLength;

		while (nOffset < nLength)
		{
			if ((nOffset in this) && (this[nOffset] === objFind)) return nOffset;
			++nOffset;
		}

		return -1;
	};
}

if (!Array.prototype.indexOf)
{
	Array.prototype.indexOf = function()
	{
		if (arguments.length != 1) return false;

		for (var nIndex = 0; this[nIndex]; ++nIndex)
		{
			if (this[nIndex] == arguments[0]) return nIndex;
		}

		return false;
	};
}

window.addEventListener('load', objDogEar.Init, false);